# vmware_guest_vnc – Manages VNC remote display on virtual machines in vCenter

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Examples
- Return Values
- Status

## Synopsis

- This module can be used to enable and disable VNC remote display on virtual machine.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- PyVmomi

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
datacenter string | Default: "ha-datacenter" | Destination datacenter for the deploy operation. This parameter is case sensitive.
folder string |  | Destination folder, absolute or relative path to find an existing guest. The folder should include the datacenter. ESX's datacenter is ha-datacenter
hostname string |  | The hostname or IP address of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead. Environment variable support added in Ansible 2.6.
moid string added in 2.9 |  | Managed Object ID of the instance to manage if known, this is a unique identifier only within a single vCenter instance. This is required if `name` or `uuid` is not supplied.
name string |  | Name of the virtual machine to work with. Virtual machine names in vCenter are not necessarily unique, which may be problematic, see `name_match`.

name_match
string

Choices:
- first ←
- last

If multiple virtual machines matching the name, use the first or last found.

password string |  | The password of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. Environment variable support added in Ansible 2.6. aliases: pass, pwd
port integer added in 2.5 | Default: 443 | The port number of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PORT` will be used instead. Environment variable support added in Ansible 2.6.
proxy_host string added in 2.9 |  | Address of a proxy that will receive all HTTPS requests and relay them. The format is a hostname or a IP. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_HOST` will be used instead. This feature depends on a version of pyvmomi greater than v6.7.1.2018.12
proxy_port integer added in 2.9 |  | Port of the HTTP proxy that will receive all HTTPS requests and relay them. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_PORT` will be used instead.

state
string

Choices:
- present ←
- absent

Set the state of VNC on virtual machine.

username string |  | The username of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. Environment variable support added in Ansible 2.6. aliases: admin, user
uuid string |  | UUID of the instance to manage if known, this is VMware's unique identifier. This is required, if `name` or `moid` is not supplied.

validate_certs
boolean

Choices:
- no
- yes ←

Allows connection when SSL certificates are not valid. Set to `false` when certificates are not trusted.
If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead.
Environment variable support added in Ansible 2.6.
If set to `yes`, please make sure Python >= 2.7.9 is installed on the given machine.

vnc_ip string | Default: "0.0.0.0" | Sets an IP for VNC on virtual machine. This is required only when state is set to present and will be ignored if state is absent.
vnc_password string | Default: "" | Sets a password for VNC on virtual machine. This is required only when state is set to present and will be ignored if state is absent.
vnc_port integer | Default: 0 | The port that VNC listens on. Usually a number between 5900 and 7000 depending on your config. This is required only when state is set to present and will be ignored if state is absent.

## Examples

    - name: Enable VNC remote display on the VM
      vmware_guest_vnc:
        hostname: "{{ vcenter_hostname }}"
        username: "{{ vcenter_username }}"
        password: "{{ vcenter_password }}"
        validate_certs: no
        folder: /mydatacenter/vm
        name: testvm1
        vnc_port: 5990
        vnc_password: vNc5ecr3t
        datacenter: "{{ datacenter_name }}"
        state: present
      delegate_to: localhost
      register: vnc_result

    - name: Disable VNC remote display on the VM
      vmware_guest_vnc:
        hostname: "{{ vcenter_hostname }}"
        username: "{{ vcenter_username }}"
        password: "{{ vcenter_password }}"
        validate_certs: no
        datacenter: "{{ datacenter_name }}"
        uuid: 32074771-7d6b-699a-66a8-2d9cf8236fff
        state: absent
      delegate_to: localhost
      register: vnc_result

    - name: Disable VNC remote display on the VM using MoID
      vmware_guest_vnc:
        hostname: "{{ vcenter_hostname }}"
        username: "{{ vcenter_username }}"
        password: "{{ vcenter_password }}"
        validate_certs: no
        datacenter: "{{ datacenter_name }}"
        moid: vm-42
        state: absent
      delegate_to: localhost
      register: vnc_result

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
changed boolean | always | If anything changed on VM's extraConfig.
failed boolean | always | If changes failed.
instance dictionary | On success in both state | Dictionary describing the VM, including VNC info.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Armin Ranjbar Daemi (@rmin)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.